﻿/*
 * Name: Hamming code generator code for redundency checking
 * Author: Sorin Liviu Jurj
 * 
 * Description:
*
*
*
*
*
*
 */

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.IO.Ports;
using System;
using System.IO;

namespace WpfApp2_uart_combobox
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {

        public MainWindow()
        {
            InitializeComponent();
        }

        bool firstFlag = false;
        string inputstring_t;
        int num_t = 0x0f;
        int len_t;
        int i, offset = 0;
        int lastbit_t;

        /*
        Button event for STEP RUN 
        */
        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            string outputstring = "";

            /*STEP RUN arrival of first step*/
            if (firstFlag == false)
            {
                firstFlag = true;
                recieve_box.IsReadOnly = true;
                /*
                checkimg if valid data is available in BOX A
                */
                if (!String.IsNullOrEmpty(recieve_box.Text))
                {
                    inputstring_t = recieve_box.Text;
                    len_t = inputstring_t.Length;
                    lastbit_t = inputstring_t[len_t - 1] == '1' ? 1 : 0;
                    totalCycles.Text = len_t.ToString();

                    /*Checks if data is binary and valid*/
                    if ((inputstring_t.Split('1').Length - 1) + (inputstring_t.Split('0').Length - 1) == len_t)
                    {
                        /*creates new signature*/
                        num_t = ((num_t << 1) & 0x08) | ((num_t << 1) & 0x04) | (((num_t >> 2) ^ (num_t << 1)) & 0x02) | (((num_t >> 3) ^ lastbit_t) & 0x01);

                        for (i = 0; i < 4; i++)
                        {
                            if (((num_t >> (3 - i)) & 0x01) == 1)
                                outputstring += '1';
                            else
                                outputstring += '0';
                        }

                        /*prints it in BOX*/
                        box_cycles.Text = (offset + 1).ToString();
                        recieve_box_Copy.Text = outputstring;
                        outputstring = "";

                        if (offset != len_t - 1)
                            lastbit_t = inputstring_t[len_t - (offset + 2)] == '1' ? 1 : 0;

                        offset++;
                        if (offset == len_t)
                        {
                            num_t = 0x0f;
                            offset = 0;
                            firstFlag = false;
                            recieve_box.IsReadOnly = false;
                        }

                    }
                    else {
                        firstFlag = false;
                        recieve_box.IsReadOnly = false;
                        MessageBoxResult result = MessageBox.Show("INPUT CONTAINS INVALID BITS");
                    }
                }
                else
                {
                    firstFlag = false;
                    recieve_box.IsReadOnly = false;
                    MessageBoxResult result = MessageBox.Show("INPUT NOT FOUND");
                }
            }
            /*STEP RUN arrival of consecutive steps*/
            else
            {
                num_t = ((num_t << 1) & 0x08) | ((num_t << 1) & 0x04) | (((num_t >> 2) ^ (num_t << 1)) & 0x02) | (((num_t >> 3) ^ lastbit_t) & 0x01);

                for (i = 0; i < 4; i++)
                {
                    if (((num_t >> (3 - i)) & 0x01) == 1)
                        outputstring += '1';
                    else
                        outputstring += '0';
                }

                box_cycles.Text = (offset + 1).ToString();
                recieve_box_Copy.Text = outputstring;
                outputstring = "";

                if (offset != len_t - 1)
                    lastbit_t = inputstring_t[len_t - (offset + 2)] == '1' ? 1 : 0;

                offset++;
                if(offset == len_t)
                {
                    num_t = 0x0f;
                    offset = 0;
                    firstFlag = false;
                    recieve_box.IsReadOnly = false;
                }
            }

        }

        /*
        Button event for RUN 
        */
        private void Button_Click_2(object sender, RoutedEventArgs e)
        {
            string inputstring;
            string outputstring = "";
            int num = 0x0f;
            int len;
            int i,j;
            int lastbit ;

            recieve_box.IsReadOnly = true;

            /*
             checkimg if valid data is available in BOX A
             */
            if (!String.IsNullOrEmpty(recieve_box.Text)){

                inputstring = recieve_box.Text;
                len = inputstring.Length;
                lastbit = inputstring[len - 1] == '1' ? 1 : 0;
                totalCycles.Text = len.ToString();

                /*Checks if data is binary and valid*/
                if ((inputstring.Split('1').Length - 1) + (inputstring.Split('0').Length - 1) == len)
                {

                    for (j = 0; j < len; j++)
                    {
                        /*creates new signature*/
                        num = ((num << 1) & 0x08) | ((num << 1) & 0x04) | (((num >> 2) ^ (num << 1)) & 0x02) | (((num >> 3) ^ lastbit) & 0x01);

                        for (i = 0; i < 4; i++)
                        {
                            if (((num >> (3 - i)) & 0x01) == 1)
                                outputstring += '1';
                            else
                                outputstring += '0';
                        }
                        /*prints it in BOX*/
                        box_cycles.Text = (j + 1).ToString();
                        recieve_box_Copy.Text = outputstring;
                        outputstring = "";

                        if (j != len - 1)
                            lastbit = inputstring[len - (j + 2)] == '1' ? 1 : 0;
                    }
                }
                else
                {
                    MessageBoxResult result = MessageBox.Show("INPUT CONTAINS INVALID BITS");
                }
            }
            else{
                MessageBoxResult result = MessageBox.Show("INPUT NOT FOUND");
            }

            num_t = 0x0f;
            offset = 0;
            firstFlag = false;
            recieve_box.IsReadOnly = false;

        }
    }  
}
